
#include "stm32f2xx_conf.h"
#include "lcd.h"
#include "main.h"
#include "kamera.h"
#include "delay.h"
#include "spi.h"

#include "fat.h"
#include "mmc_config.h"
#include "mmc.h"
#include "file.h"

#include "bmp.h"

//128x96
uint32_t kamera_buffer1[9600];// 11616
unsigned int bilder;
unsigned int bilder1=0;

void gpio_clock_init(void);
void led_init(void);
unsigned int itoa_g (unsigned int i,char * data);
void mmc_pio_setup(void);


void gpio_io_install(void)
{
	gpio_clock_init();
	led_init();
	LED_ON();
	lcd_pio_config();
	mmc_pio_setup();
	SPI_Config();
}
void buffer_lcd(void)
{
	unsigned short int i;
		lcd_command(0xEF80);
		lcd_command(0x1804);//0x1800
	  	lcd_command(ASX);
	  	lcd_command(AEX+119);//131
	  	lcd_command(ASY);
	  	lcd_command(AEY+159);//175
		GPIOD->BSRRH= GPIO_Pin_0; //FIOSET0 = (1<<LCD_RS_GPIO);
	  	for (i=0; i<9600; i++)
		{
	  		lcd_data(kamera_buffer1[i] & 0xFFFF);
			lcd_data((kamera_buffer1[i]>>16) & 0xFFFF);
		}
	  	GPIOD->BSRRL= GPIO_Pin_2;
}
int install_sd(void)
{
	if( FALSE == mmc_init() )
	{

		lcd_print(10,120,0x1F,0xFFFF,"MMC Init faled!");
		while(1);
	} 


	if( FALSE == fat_loadFatData() )

	{
		lcd_print(10,120,0x1F,0xFFFF,"FAT Init faled!");

		while(1);
	}
	lcd_print(10,120,0x1F,0xFFFF,"MMC Init ");

	
}
void print_bilder(void)
{
	char buffer[50];
	itoa_g(bilder,&buffer[0]);
	lcd_print(10,10,0x1F,0xFFFF,&buffer[0]);
}

void save_bild(void)
{
	BITMAPFILEHEADER bmh;
	BITMAPINFOHEADER bih;
	char buffer[50];
	unsigned int i=0;

	bmh.bfType=19778;
	bmh.bfSize=57654;
	bmh.bfReserved1=0;
	bmh.bfReserved2=0;
	bmh.bfOffBits=54;

	bih.biSize = 40; 
	bih.biWidth=160;
	bih.biHeight=120;
	bih.biPlanes=1;
	bih.biBitCount=24;
	bih.biCompression=0;
	bih.biSizeImage=57600;
	bih.biXPelsPerMeter=0;
	bih.biYPelsPerMeter=0;
	bih.biClrUsed=0;
	bih.biClrImportant=0;

	itoa_g(bilder1,&buffer[0]);
				for(i=0;i<12;i++)
				{

					if(buffer[i]==0)
					{
						buffer[i]='.';
						buffer[i+1]='b';

						buffer[i+2]='m';
						buffer[i+3]='p';
						buffer[i+4]=0;
						break;
					}
				}
				if(MMC_FILE_CREATED == ffopen(buffer,'c') )
				{
					LED_OFF();
					
					unsigned char *zeiger1 =	&bmh;

					for(i=0;i<14;i++)
					{
						ffwrite(*zeiger1);
						zeiger1++;

					}
					unsigned char *zeiger2 =	&bih;
					for(i=0;i<40;i++)
					{

						ffwrite(*zeiger2);
						zeiger2++;
					}


					unsigned short *bufferk=	&kamera_buffer1[0];
					unsigned short pixel;
					unsigned char r,g,b;					
					for(i=0;i<9600;i++)
					{					
						pixel=*bufferk++;
						b=pixel & 0x1F;
						g=(pixel>>5) & 0x3f;
						r=(pixel>>11) & 0x1F;

						ffwrite(b<<3);
						ffwrite(g<<2);
						ffwrite(r<<3);

						pixel=*bufferk++;
						b=pixel & 0x1F;
						g=(pixel>>5) & 0x3f;
						r=(pixel>>11) & 0x1F;

						ffwrite(b<<3);
						ffwrite(g<<2);
						ffwrite(r<<3);
				   	}
					ffclose();
					LED_ON();
 
				}

			
}



int main(void)
{
	
	char buffer[50];

 	gpio_io_install();

	lcd_init();
	lcd_cls(0xFFFF);
	
	install_sd();
	//dir_list("/");
	//lcd_print(10,100,0x1F,0xFFFF,"DIR ok");


	bilder=0;
	tcm8230_init();
	DCMI_Cmd(ENABLE); 
	DCMI_CaptureCmd(ENABLE); 
	while(1)
	{
		if(bilder==1)
		{
			save_bild();
			bilder=0;
			bilder1++;
			DCMI_CaptureCmd(ENABLE); 
		}
		itoa_g(bilder1,&buffer[0]);
		lcd_print(10,90,0x1F,0xFFFF,&buffer[0]);
		
	}
	
}




void mmc_pio_setup(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3 ;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_25MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	GPIOD->BSRRL = GPIO_Pin_3  ;//CS_H

}

void gpio_clock_init(void)
{
	RCC_AHB1PeriphClockCmd(	RCC_AHB1Periph_GPIOA |
				RCC_AHB1Periph_GPIOB |
				RCC_AHB1Periph_GPIOC |
				RCC_AHB1Periph_GPIOD |
				RCC_AHB1Periph_GPIOE ,ENABLE );

}

void led_init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	/* Configure PA2 as LED */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2 ;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}

unsigned int itoa_g (unsigned int i,char * data)
{
	char d[100];
	
	unsigned int len=0;
	unsigned int ret=0;

	do {
		d[len] = '0' + (i % 10);
		i /= 10;
		len++;
	} while (i);
	ret=len;

	do {
		*data =d[len-1];
		data++;
		len--;
	}while(len);
	*data=0;
	return ret;
}







/*


	bmh.bfType=19778;
	bmh.bfSize=38454;
	bmh.bfReserved1=0;
	bmh.bfReserved2=0;
	bmh.bfOffBits=54;

	bih.biSize = 40; 
	bih.biWidth=160;
	bih.biHeight=120;
	bih.biPlanes=1;
	bih.biBitCount=16;
	bih.biCompression=0;
	bih.biSizeImage=38400;
	bih.biXPelsPerMeter=0;
	bih.biYPelsPerMeter=0;
	bih.biClrUsed=65536;
	bih.biClrImportant=0;

			if(bilder==1)
			{
				itoa_g(bilder1,&buffer[0]);
				for(i=0;i<12;i++)
				{
					if(buffer[i]==0)
					{
						buffer[i]='.';
						buffer[i+1]='b';
						buffer[i+2]='m';
						buffer[i+3]='p';
						buffer[i+4]=0;
						break;
					}
				}
				if(MMC_FILE_CREATED == ffopen(buffer,'c') )
				{
					LED_OFF();
					unsigned char *bufferk=	&kamera_buffer1[0];
					unsigned char *zeiger1 =	&bmh;
					for(i=0;i<14;i++)
					{
						ffwrite(*zeiger1);
						zeiger1++;
					}
					unsigned char *zeiger2 =	&bih;
					for(i=0;i<40;i++)
					{
						ffwrite(*zeiger2);
						zeiger2++;
					}

										
					for(i=0;i<9600;i++)
					{					

						ffwrite(*bufferk++);
						ffwrite(*bufferk++);
						ffwrite(*bufferk++);
						ffwrite(*bufferk++);
				   	}
					ffclose();
					LED_ON();
					bilder=0;
					bilder1++;
					DCMI_CaptureCmd(ENABLE); 
				}
			}
		//buffer_lcd();	
*/

/*
		if(bilder==100)
		{
			if(MMC_FILE_CREATED == ffopen("d.bmp",'c') )
			{
				LED_OFF();
				unsigned char *bufferk=	&kamera_buffer1[0];			
				for(i=0;i<11616;i++)
				{					
					ffwrite(*bufferk++);
					ffwrite(*bufferk++);
					ffwrite(*bufferk++);
					ffwrite(*bufferk++);
			   	}
				ffclose();
				LED_ON();
			} 	
		}
		
		itoa_g(bilder,&buffer[0]);
		lcd_print(10,10,0x1F,0xFFFF,&buffer[0]);
		*/

















/*
int fat_init(void)
{
	char buff[50];
	int ant=0;
	unsigned char buffer[512];
	FAT32_BOOTSEC * boot_sec=&buffer[0];
	unsigned int RootDirSectors=0;
	unsigned int FATSz=0;
	unsigned int TotSec=0;
	unsigned int DataSec=0;
	unsigned int CountofClusters=0;

	ant=media_read(0,&buffer[0]);
	if(ant!=1)
	{
		lcd_print(10,20,0x1F,0xFFFF,"MMC read faled!");
		itoa_g(ant,&buff[0]);
		lcd_print(10,30,0x1F,0xFFFF,&buff[0]);

		return 0;
	}

	

	RootDirSectors = ((boot_sec->BPB_RootEntCnt *32)+(boot_sec->BPB_BytsPerSec-1)) /boot_sec->BPB_BytsPerSec;
	if(boot_sec->BPB_FATSz16 != 0)
		FATSz = boot_sec->BPB_FATSz16;
	else

		FATSz = boot_sec->BPB_FATSz32;  

	if(boot_sec->BPB_TotSec16 != 0)
		TotSec = boot_sec->BPB_TotSec16;

	else
		TotSec = boot_sec->BPB_TotSec32;


	
	DataSec = TotSec -(boot_sec->BPB_RsvdSecCnt +(boot_sec->BPB_NumFATs*FATSz)+RootDirSectors);

	CountofClusters = DataSec / boot_sec->BPB_SecPerClus;


	itoa_g(RootDirSectors,&buff[0]);
	lcd_print(10,90,0x1F,0xFFFF,&buff[0]);
	

	itoa_g(DataSec,&buff[0]);
	lcd_print(10,80,0x1F,0xFFFF,&buff[0]);

	itoa_g(CountofClusters,&buff[0]);

	lcd_print(10,70,0x1F,0xFFFF,&buff[0]);

	if(CountofClusters < 4085) 
	{

		//FAT12
		lcd_print(10,60,0x1F,0xFFFF,"FAT12");
	}
	else if(CountofClusters < 65525) 

	{
		//FAT16 
		lcd_print(10,60,0x1F,0xFFFF,"FAT16");
	} 

	else 
	{
		//FAT32 

		lcd_print(10,60,0x1F,0xFFFF,"FAT32");
	}
	return 1;


}
*/

/*
typedef struct 
{
	char BS_jmpBoot[2];
	char BS_OEMName[7];
	unsigned short BPB_BytsPerSec;
	unsigned char BPB_SecPerClus;
	unsigned short BPB_RsvdSecCnt;
	unsigned char BPB_NumFATs;
	unsigned short BPB_RootEntCnt;
	unsigned short BPB_TotSec16;
	unsigned char BPB_Media;
	unsigned short BPB_FATSz16;
	unsigned short BPB_SecPerTrk;
	unsigned short BPB_NumHeads;
	unsigned int BPB_HiddSec;
	unsigned int BPB_TotSec32;

	unsigned char BS_DrvNum;
	unsigned char BS_Reserved1;
	unsigned char BS_BootSig;
	unsigned int BS_VolID;

	char BS_VolLab[10];
	char BS_FilSysType[7];//62 next
	char BS_Boot_code[447];

	unsigned short BS_Signatur;

}FAT16_BOOTSEC;


typedef struct 
{
	char BS_jmpBoot[2];
	char BS_OEMName[7];

	unsigned short BPB_BytsPerSec;
	unsigned char BPB_SecPerClus;
	unsigned short BPB_RsvdSecCnt;
	unsigned char BPB_NumFATs;

	unsigned short BPB_RootEntCnt;
	unsigned short BPB_TotSec16;
	unsigned char BPB_Media;
	unsigned short BPB_FATSz16;

	unsigned short BPB_SecPerTrk;
	unsigned short BPB_NumHeads;
	unsigned int BPB_HiddSec;
	unsigned int BPB_TotSec32;


	unsigned int BPB_FATSz32;
	unsigned short BPB_ExtFlags;

	unsigned short BPB_FSVer;
	unsigned int BPB_RootClus;
	unsigned short BPB_FSInfo;
	unsigned short BPB_BkBootSec;

	unsigned char BPB_Reserved[11];
	unsigned char BS_DrvNum;
	unsigned char BS_Reserved1;
	unsigned char BS_BootSig;

	unsigned int BS_VolID;
	char BS_VolLab[10]; 
	char BS_FilSysType[7];
	char BS_Boot_code[419];

	unsigned short BS_Signatur;
}FAT32_BOOTSEC;
*/



	/*
	if(media_init()==0)
	{
		lcd_print(10,20,0x1F,0xFFFF,"MMC Init faled!");
		while(1);
	}
	lcd_print(10,40,0x1F,0xFFFF,"MMC Init");
	fat_init();
	*/

/*
		unsigned short int i;
		lcd_command(0xEF80);
		lcd_command(0x1804);//0x1800

	  	lcd_command(ASX);
	  	lcd_command(AEX+131);
	  	lcd_command(ASY);
	  	lcd_command(AEY+175);

	  	//udelay(10);

		GPIOD->BSRRH= GPIO_Pin_0; //FIOSET0 = (1<<LCD_RS_GPIO);

	  	for (i=0; i<11616; i++)
		{
	  		lcd_data(kamera_buffer2[i] & 0xFFFF);
			lcd_data((kamera_buffer2[i]>>16) & 0xFFFF);
		}
	  	GPIOD->BSRRL= GPIO_Pin_2;

		*/
/*

	//spfd5420_init();
	//spfd5420_cls(0x0);

spfd5420Command(0x0210, 0x0000);    // Window Horizontal RAM Address Start (R210h)
	spfd5420Command(0x0211, 119);    // Window Horziontal RAM Address End (R211h)  0x00EF
	spfd5420Command(0x0212, 0x0000);    // Window Vertical RAM Address Start (R212h)
	spfd5420Command(0x0213, 159);    // Window Vertical RAM Address End (R213h)    0x018F
	while (1)
	{
		

		
		spfd5420Command(0x0200,0);//GRAM Address Set (Horizontal Address) (R200h)
		spfd5420Command(0x0201,0);//GRAM Address Set (Vertical Address) (R201h)
		GPIOD->BSRRH= PIN_CS ;
		GPIOD->BSRRH= PIN_RS;//BSRRH->Clear
		GPIOD->BSRRL= PIN_RD | PIN_WR;//BSRRL->SET
		GPIOE->ODR = 0x0202;
	
		GPIOD->BSRRH= PIN_WR;//CLR_WR;
		//delay(12);
		GPIOD->BSRRL=PIN_WR ;//SET_WR;
		GPIOD->BSRRL=PIN_RS;//SET_CD;
		for (i=0;i<9600;i++)
		{
			GPIOE->ODR =kamera_buffer1[i] & 0xFFFF;
			GPIOD->BSRRH= PIN_WR;//CLR_WR;
			//delay(12);
			GPIOD->BSRRL=PIN_WR ;//SET_WR;
				
			GPIOE->ODR =(kamera_buffer1[i]>>16) & 0xFFFF;
			GPIOD->BSRRH= PIN_WR;//CLR_WR;
			//delay(12);
			GPIOD->BSRRL=PIN_WR ;//SET_WR;
		}
		
		i=0;
		for(y=0;y<120;y++)
		{
			GPIOD->BSRRL= PIN_CS;//SET_CS;//Chip select off
			spfd5420Command(0x0200,y);GRAM Address Set (Horizontal Address) (R200h)
			spfd5420Command(0x0201,0);GRAM Address Set (Vertical Address) (R201h)
			GPIOD->BSRRH= PIN_CS ;
			GPIOD->BSRRH= PIN_RS;//BSRRH->Clear
			GPIOD->BSRRL= PIN_RD | PIN_WR;//BSRRL->SET
			GPIOE->ODR = 0x0202;
	
			GPIOD->BSRRH= PIN_WR;//CLR_WR;
			GPIOD->BSRRL=PIN_WR ;//SET_WR;
			GPIOD->BSRRL=PIN_RS;//SET_CD;
		
			for (x=0;x<80;x++)
			{
				
				GPIOE->ODR =kamera_buffer1[i] & 0xFFFF;

				GPIOD->BSRRH= PIN_WR;//CLR_WR;
				GPIOD->BSRRL=PIN_WR ;//SET_WR;
				
				GPIOE->ODR =(kamera_buffer1[i]>>16) & 0xFFFF;

				GPIOD->BSRRH= PIN_WR;//CLR_WR;
				GPIOD->BSRRL=PIN_WR ;//SET_WR;
				i++;	
				

			}
		}
		
		


	}

*/





		/* Set PG6 and PG8 */
		//GPIOC->BSRRL = GPIO_Pin_4;
		/* Reset PG6 and PG8 */
		//GPIO_SetBits(GPIOC,GPIO_Pin_4);
		//Delay(1000000);
		//GPIO_ResetBits(GPIOC,GPIO_Pin_4 ); //Setzt die Bits 2 und 9 am GPIOA auf low 
		//GPIOC->BSRRH = GPIO_Pin_4;

		//Delay(1000000);
