
#include "stm32f2xx_conf.h"

unsigned char spi_write_byte(unsigned char data)
{
	SPI2->DR=data;	
	while(!(SPI2->SR & 0x2));
	return SPI2->DR; 

	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);
	//SPI2->CR1 &= ~(1<<11);
	//SPI_I2S_SendData(SPI2, data);
	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);
	//while(SPI2->SR & 0x1);
	//return (unsigned char)SPI_I2S_ReceiveData(SPI2);
}
unsigned char spi_read_byte(void)
{
	
	
	
	SPI2->DR=0xFF;	
	while(!(SPI2->SR & 0x2));
	return SPI2->DR;

	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);
	//SPI2->CR1 &= ~(1<<11);
	//SPI_I2S_SendData(SPI2, 0xFF);
	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);
	//return (unsigned char)SPI_I2S_ReceiveData(SPI2);
}
unsigned short spi_write_short(unsigned short data)
{
	unsigned short ret;
	SPI2->DR= (unsigned char)((data>>8) & 0xFF);
	while(!(SPI2->SR & 0x2));	
	ret=(unsigned char) SPI2->DR;//SPI_I2S_ReceiveData(SPI2);
	ret=(ret<<8);
	SPI2->DR= (unsigned char)(data & 0xFF);
	while(!(SPI2->SR & 0x2));	
	ret|=(unsigned char)SPI2->DR;//(unsigned char)SPI_I2S_ReceiveData(SPI2);
	return ret;

	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);
	//SPI_I2S_SendData(SPI2, (unsigned char) ((data>>8) & 0xFF) );
	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);
	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);
	//SPI_I2S_SendData(SPI2, (unsigned char)(data & 0xFF));
	//while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);
	//ret|=(unsigned char)SPI_I2S_ReceiveData(SPI2);
}
unsigned short spi_read_short(void)
{
	
	unsigned short ret;
	SPI2->DR=  0xFF;
	while(!(SPI2->SR & 0x2));
	ret=SPI2->DR;
	ret=(ret<<8);
	SPI2->DR=  0xFF;
	while(!(SPI2->SR & 0x2));
	ret|=SPI2->DR;
	return ret;
}
void spi_set_baud(unsigned char pre)
{
	unsigned char Baud=pre & 0x7;
	SPI2->CR1 &= ~(0x7<<3);
	SPI2->CR1 |=(Baud<<3);
}
void SPI_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;

	/* Enable the SPI clock */
	SPI_Cmd(SPI2, DISABLE);

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2 , ENABLE);
	
	
	/* Connect SPI pins to AF5 */  
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource13, GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource14, GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource15, GPIO_AF_SPI2);

	/* SPI SCK MOSI */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13   |GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	/* SPI MISO */
	GPIO_InitStructure.GPIO_Pin =GPIO_Pin_14 ;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	

	/* SPI configuration -------------------------------------------------------*/
	SPI_I2S_DeInit(SPI2);

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b ;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;

	
	SPI_Init(SPI2, &SPI_InitStructure);
	//SPI_CalculateCRC(SPI2, DISABLE);
	//SPI_SSOutputCmd(SPI2,DISABLE);
	//SPI_I2S_ITConfig(SPI2,SPI_I2S_IT_TXE,DISABLE);
	//SPI_I2S_ITConfig(SPI2,SPI_I2S_IT_RXNE,DISABLE);
	//SPI_I2S_ITConfig(SPI2,SPI_I2S_IT_ERR,DISABLE);
	//SPI2->CR2=0;//0x80;	
	SPI_Cmd(SPI2, ENABLE);

		

	


	/* Configure the Priority Group to 1 bit */                
	//NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	  
	/* Configure the SPI interrupt priority 
	NVIC_InitStructure.NVIC_IRQChannel = SPI2_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	*/
}
